
Ember.StrongappAdapter = Ember.Object.extend({
    init: function() {
        this.loadData();
    },
    loadData: function() {

        try {
            this._data = JSON.parse(file.reader());    
        } catch (err) {
            this._data = [];
        }


        
        ac = window.App.__container__.lookup('controller:application')
        ac.set("connectionDB", this._data);
        ac.set("connectionDBlength", this._data.length);

        for (var i = 0; i < this._data.length; i++) {
            item = this._data[i];
            
            if(item["position"] == undefined) {
                item["position"] = i;
            }

            if(item["encryptedPassword"] != undefined) {
            	item["password"] = item["encryptedPassword"];
            }


        	try {
        		item["password"] = keychain.get(item["server"], item["username"], item["type"], item["port"], item["password"]);
        	} catch (err) {
        		expandrive.log("could not load encryptedPassword");
        	}

            if (item["password"] != "" && item["password"] != undefined) {
                item["save_password"] = true;
            }
        }
    },

    saveData: function() {
        file.writer(JSON.stringify(this._data, null, 2));

        ac = window.App.__container__.lookup('controller:application')
        ac.set("connectionDB", this._data);
        ac.set("connectionDBlength", this._data.length);
    },
    generateIdForRecord: function() {
        return Math.random().toString(32).slice(2).substr(0, 8);
    },
    find: function(record, id) {

        this.loadData();


        return new Ember.RSVP.Promise(function(resolve, reject) {
            Ember.run.later(this, function() {
                Ember.run(record, record.load, id, this._data);
                resolve(record);
            }, 0);
        });
    },


    findMany: function(klass, records, ids) {
        var fixtures = klass.FIXTURES,
            requestedData = [];

        for (var i = 0, l = ids.length; i < l; i++) {
            requestedData.push(this._findData(klass, ids[i]));
        }

        return new Ember.RSVP.Promise(function(resolve, reject) {
            Ember.run.later(this, function() {
                Ember.run(records, records.load, klass, requestedData);
                resolve(records);
            }, 0);
        });
    },

    findAll: function(klass, records) {
        self = this;
        this.loadData();
        p = new Ember.RSVP.Promise(function(resolve, reject) {
            Ember.run.later(this, function() {
                Ember.run(records, records.load, klass, self._data);
                resolve(records);
            }, 0);
        });
        return p;
    },

    createRecord: function(record) {

    	record.savePassword();
        record_json = record.cleanJSON();
        record_json["id"] = this.generateIdForRecord();
        record.set("id", record_json["id"]);
        record.id = record_json["id"];
        this._data.push(record_json);

        window.App.__container__.lookup('controller:application').set("connectionDB", this._data)
        
        
        this.saveData();
        

        return new Ember.RSVP.Promise(function(resolve, reject) {
            Ember.run.later(this, function() {
                record.didCreateRecord();
                resolve(record);
            }, 0);
        });
    },

    saveRecord: function(record) {

        var id = record.get('id');
        record.savePassword();
        
        for (var i = 0; i < this._data.length; i++) {
            if (this._data[i]["id"] == id) {
                record_json = record.cleanJSON();
                this._data[i] = record_json;
                console.log(JSON.stringify(record_json));
            }
        }

        this.saveData();
        

        return new Ember.RSVP.Promise(function(resolve, reject) {
            Ember.run.later(this, function() {
                record.didSaveRecord();
                resolve(record);
            }, 0);
        });
    },

    deleteRecord: function(record) {

        var id = record.get('id');
        this._data = this._data.filter(function(item) {
            return item["id"] != id;
        });

        this.saveData();

        return new Ember.RSVP.Promise(function(resolve, reject) {
            Ember.run.later(this, function() {
                record.didDeleteRecord();
                resolve(record);
            }, 0);
        });
    }
});
