App.WelcomeRoute = Ember.Route.extend({
    setupController: function(controller, model) {
        this.controllerFor('index').set('sidebarActiveButton', "welcome-active");
        controller.set('model', model);
    },
    renderTemplate: function() {
        this.render('sidebar', { // the template to render
            outlet: 'sidebar', // the name of the outlet in the route's template
            controller: 'index' // the controller to use for the template
        });
        this.render('welcome', {
            outlet: 'content',
        });
        this.render('blank', {
            outlet: 'details',
        });
    },
    model: function() {
        return App.license;
    },
});

App.WelcomeController = Ember.ObjectController.extend({

    showSerial: false,

    name: "",

    email: "",

    serial: null,

    actions: {
        alreadyHave: function() {
            this.set("showSerial", true);
        },
        startTrial: function() {
            App.license.requestTrial(this.get("name"), this.get("email"), function() {
                this.transitionToRoute("new");
            }, this);
        },
        activate: function() {
            App.license.set("serial", this.get("serial"));
            App.license.activateSerial(function() {
                alert("Thanks for purchasing ExpanDrive!");
                this.transitionToRoute("new");
            }, this);
        }
    },
});
